<!DOCTYPE html>
<html>

<head>
  <title>Task 62</title>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>
</head>

<body>
  <div class="container">
    <h2 class="text-center">DANH SÁCH CÁC PHƯỜNG XÃ QUẬN HUYỆN VÀ CÁC TỈNH THÀNH PHỐ</h2>
    <form id="inputform01" class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-4">
          <label for="province"><b>Tỉnh thành phố</b></label>
        </div>
        <div class="col-sm-8">
          <select id="province-select" name="province" class="form-control">
            <option value="all">Tỉnh thành phố</option>
          </select>
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-4">
          <label for="district"><b>Quận huyện</b></label>
        </div>
        <div class="col-sm-8">
          <select id="district-select" disabled name="district-select" class="form-control">
            <option value="all">Quận huyện</option>
          </select>
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-4">
          <label for="ward"><b>Phường xã</b></label>
        </div>
        <div class="col-sm-8">
          <select id="ward-select" disabled name="ward-select" class="form-control">
            <option value="all">Phường xã</option>
          </select>
        </div>
      </div>
    </form>
  </div>
  <script>
    //Get data province
    $.ajax({
      url: "http://localhost:8080/provinces",
      method: "GET",
      success: function (pObjRes) {
        console.log(pObjRes);
        loadDataToProvinceSelect(pObjRes);
      },
      error: function (pXhrObj) {
        console.log(pXhrObj);
      }
    });

    var gProvinceSelectElement = $("#province-select");

    function loadDataToProvinceSelect(pProvinceList) {
      for (i = 0; i < pProvinceList.length; i++) {
        var bProvinceOption = $("<option/>");
        bProvinceOption.prop("value", pProvinceList[i].id);
        bProvinceOption.prop("text", pProvinceList[i].name);
        gProvinceSelectElement.append(bProvinceOption);
      };
    }

    var gDistrictSelectElement = $("#district-select");

    //callback function
    gProvinceSelectElement.on("change", function () {
      gDistrictSelectElement.html("");
      var bProvinceId = $(this).val();
      console.log(bProvinceId);

      getDistrictByProvinceId(bProvinceId);
    });

    //find brandTypes array by brandId
    function getDistrictByProvinceId(bProvinceId) {
      $.ajax({
        url: "http://localhost:8080/districts?provinceId=" + bProvinceId,
        method: "GET",
        success: function (pObjRes) {
          console.log(pObjRes);
          loadDataToDistrictSelect(pObjRes);
        },
        error: function (pXhrObj) {
          console.log(pXhrObj);
        }
      });
    }

    function loadDataToDistrictSelect(pDistrictList) {
      if (pDistrictList.length > 0) {
        gDistrictSelectElement.prop("disabled", false);

        for (i = 0; i < pDistrictList.length; i++) {
          var bDistrictOption = $("<option/>");
          bDistrictOption.prop("value", pDistrictList[i].id);
          bDistrictOption.prop("text", pDistrictList[i].name);
          gDistrictSelectElement.append(bDistrictOption);
        };
      } else {
        gDistrictSelectElement.prop("disabled", "disabled");
      }
    }

    var gWardSelectElement = $("#ward-select");
    //callback function


    gDistrictSelectElement.on("change", function () {
      gWardSelectElement.html("");
      var bDistrictId = $(this).val();
      console.log(bDistrictId);
      getWardByDistrictId(bDistrictId);
    });

    function getWardByDistrictId(bDistrictId) {
      $.ajax({
        url: "http://localhost:8080/wards?districtId=" + bDistrictId,
        method: "GET",
        success: function (pObjRes) {
          console.log(pObjRes);
          loadDataToWardSelect(pObjRes);
        },
        error: function (pXhrObj) {
          console.log(pXhrObj);
        }
      });
    }

    function loadDataToWardSelect(pWardList) {
      if (pWardList.length > 0) {
        gWardSelectElement.prop("disabled", false);

        for (i = 0; i < pWardList.length; i++) {
          var bWardOption = $("<option/>");
          bWardOption.prop("value", pWardList[i].id);
          bWardOption.prop("text", pWardList[i].name);
          gWardSelectElement.append(bWardOption);
        };
      } else {
        gWardSelectElement.prop("disabled", "disabled");
      }
    }

  </script>
</body>

</html>